#lang racket
(require "util.rkt" json rackunit)

(define input (get-input file->string 12 "first"))

(define (solve-first input)
  (apply + (map string->number (regexp-match* #px"-?\\d+" input))))

(define (ignore? ht)
  (for/first ([v (in-hash-values ht)]
              #:when (or (and (symbol? v)
                              (equal? v 'red))
                         (and (string? v)
                              (string=? v "red"))))
    #t))


(define (sum-nums jsexpr)
  (for/fold ([acc 0])
            ([i ((if (hash? jsexpr)
                     in-hash-values
                     in-list) jsexpr)])
    (cond [(number? i) (+ acc i)]
          [(list? i) (+ acc (sum-nums i))]
          [(hash? i) (if (ignore? i)
                         acc
                         (+ acc (sum-nums i)))]
          [(string? i) acc]
          [else (begin (displayln (string? i))
                       acc)])))


;; (define j ())
(define (solve-second str)
  (sum-nums (string->jsexpr str)))
(module+ test
  (check-equal? (solve-second "[1,2,3]") 6)
  (check-equal? (solve-second "[1,{\"c\":\"red\",\"b\":2},3]") 4)
  (check-equal? (solve-second "[{\"d\":\"red\",\"e\":[1,2,3,4],\"f\":5}]") 0)
  (check-equal? (solve-second "[1,\"red\",5]") 6)
  )
