#lang racket

(require rackunit "util.rkt")

(define input (get-input file->lines 13 "first"))
(define input2 (get-input file->lines 13 "second"))

(define (get-ht lines)
  (for/hash ([line (in-list lines)])
    (let*-values ([(pattern) #px"(\\w+) would (\\w+) (\\d+) happiness units by sitting next to (\\w+)\\."]
                  [(name sign happiness neighbor) (apply values (rest (regexp-match pattern line)))])
      (values (string-append name "->" neighbor)
              (* (if (string=? sign "lose") -1 1)
                 (string->number happiness))))))

(define (get-names lines)
  (let ([names (for/list ([line (in-list lines)])
                 (first (string-split line)))])
    (remove-duplicates names)))


(define (solve-first lines)

  (define ht (get-ht lines))

  (define names (get-names lines))

  (define (get-happiness names)
    (define previous-results (make-hash))
    (let ([calc (λ (names)(for/fold ([acc 0])
                                    ([i (in-list names)]
                                     [i+1 (in-list (append (rest names)
                                                           (list (first names))))])
                            (+ acc (hash-ref ht (string-append i "->" i+1)))))]
          [key (apply string-append names)])
      (if (hash-has-key? previous-results key)
          (hash-ref previous-results key)
          (begin
            (hash-set! previous-results key (calc names))
            (hash-ref previous-results key)))))
  (define possible-solutions
    (for/list ([names (in-permutations names)])
      (+ (get-happiness names) (get-happiness (reverse names)))))
  (apply max possible-solutions))

(module+ test
  (check-equal? (solve-first (get-input file->lines 13 "test")) 330)
  )
