#lang racket
(require "util.rkt" rackunit)

(define (parse-line line) (map string->number (string-split (string-trim line) "x")))

(define (solve-first in)
  (for/fold ([paper 0])
            ([line (in-lines in)])
    (let*-values ([(dimensions) (parse-line line)]
                  [(l w h) (apply values dimensions)]
                  [(sides) (map ((curry apply) *) (list (list l w)
                                                        (list w h)
                                                        (list h l)))]
                  [(extra-paper) (apply min sides)])
      (+  extra-paper paper (apply + (map (λ (x) (* x 2)) sides))))))


(define (call-on-input f)
  (let* ([in (get-input open-input-file 2 "first")]
       [answer (f in)])
  (begin
    (close-input-port in)
    answer)))

(call-on-input solve-first)

(module+ test
  (check-equal? (call-with-input-string "2x3x4" solve-first) 58)
  (check-equal? (call-with-input-string "1x1x10" solve-first) 43))

(define (solve-second in)
  (for/fold ([ribbon 0])
            ([line (in-lines in)])
    (let* ([dimensions (parse-line line)]
           [bow (apply * dimensions)]
           [package (* 2 (apply + (take (sort dimensions <) 2)))])
      (+ bow package ribbon))))

(call-on-input solve-second)

(module+ test
  (check-equal? (call-with-input-string "2x3x4" solve-second) 34)
  (check-equal? (call-with-input-string "1x1x10" solve-second)14))
