#lang racket
(require file/md5 rackunit)
(define input "yzbqklnj")


(define (make-starts-with-x-zeros? x)
  (λ (str)
    (define pattern (regexp (string-append "^"
                                           (make-string x #\0))))
    (regexp-match? pattern str)))

;; (define starts-with-five-zeros? (make-starts-with-x-zeros? 5))

;; (define (solve-first input)
;;   (define (get-md5 n)
;;     (md5 (string-append input (number->string n))))
;;   (for/first ([i (in-naturals 1)]
;;               #:when (starts-with-five-zeros? (get-md5 i)))
;;     i))

(define (make-solve x)
  (define (solve input)
  (define (get-md5 n)
    (md5 (string-append input (number->string n))))
  (for/first ([i (in-naturals 1)]
              #:when ((make-starts-with-x-zeros? x) (get-md5 i)))
    i))
  solve)

(define solve-first (make-solve 5))

(module+ test
  (check-equal? (solve-first input) 282749)
  (check-equal? (solve-first "pqrstuv") 1048970)
  (check-equal? (solve-first "abcdef") 609043))
