#lang racket

(module+ test
  (require rackunit))
;; (provide closest-intersection)

(define (read-instructions)
  (call-with-input-file "../input/day30.txt"
    (λ (in) (list (read-line in) (read-line in)))))

(define (split-instructions instructions)
  (map string-trim (string-split instructions ",")))

(define (instructions->section-list instructions)
  (define (iter instructions-lst result current-posn)
    (if (empty? instructions-lst)
        result
        (iter (rest instructions-lst)
              (cons (instruction->section current-posn
                                          (first instructions-lst))))))
  (iter  instructions '() (list 0 0)))


(define (instruction->section current-posn instruction)
  (let* ([instruction-lst (string->list instruction)]
         [direction (direction->posn (first instruction-lst))]
         [steps (map (λ (x) (* x (string->integer (list->string (rest instruction-lst))))) direction)]
         [end-posn (posn-add current-posn steps)])
    (list current-posn end-posn)))

(module+ test
(check-equal? (instruction->section (list 0 0) "U1") (list (list 0 0) (list 0 1)))
(check-equal? (instruction->section (list 0 0) "D1") (list (list 0 0) (list 0 -1)))
(check-equal? (instruction->section (list 0 0) "L1") (list (list 0 0) (list -1 0)))
(check-equal? (instruction->section (list 0 0) "R1") (list (list 0 0) (list 1 0))))


(define (string->integer str)
  (define (iter digits result)
    (if (empty? digits)
        result
        (let* ([digit (- (char->integer (car digits))
                         48)]
               [place (expt 10 (- (length digits) 1))]
               [product (* digit place)])
          (iter (cdr digits) (+ result product)))))
  (iter (string->list str) 0))

(define (posn-add posn1 posn2)
  (list (+ (car posn1) (car posn2))
        (+ (car (cdr posn1)) (car (cdr posn2)))))

(define (direction->posn direction)
  (cond ((eq? direction #\U) (list 0 1))
        ((eq? direction #\D) (list 0 -1))
        ((eq? direction #\R) (list 1 0))
        ((eq? direction #\L) (list -1 0))))

;; (define (closest-intersection lst1 lst2)
;;   (let* ([set1 (instruction-string->posn-set lst1)]
;;         [set2 (instruction-string->posn-set lst2)]
;;         [intersection (set->list (set-intersect set1 set2))])
;;     (begin (define with-hamming (for/list ([p intersection])
;;                                   (posn-hamming (posn-x p) (posn-y p) (hamming-distance p))))
;;            (posn-hamming-hamming (car (cdr (sort with-hamming #:key posn-hamming-hamming <)))))))

;; (struct posn (x y)
;;   #:transparent)
;; (struct posn-hamming posn (hamming)
;;   #:transparent)
;; ;set aus beiden erstellen Schnittmenge bilden und nach hammingdistance sortieren
;; (define (instruction-string->posn-set instruction-string)
;;   (define (iter instruction-lst result) 
;;     (if (empty? instruction-lst)
;;         (list->set result)
;;         (iter (cdr instruction-lst)
;;               (append (path-points (car result)
;;                                    (car instruction-lst))
;;                       result))))
;;   (let ([lst (map string-trim (string-split instruction-string ","))])
;;     (iter lst (list (posn 0 0)))))


;; (define (hamming-distance posn)
;;   (foldl + 0 (map abs (list (posn-x posn) (posn-y posn)))))

;; (define (path-points current-posn instruction)
;;   (let* ([instruction-lst (string->list instruction)]
;;          [direction (car instruction-lst)]
;;          [count (string->integer (list->string (cdr instruction-lst)))]
;;          [direction-posn (direction->posn direction)])
;;     (define (iter count result)
;;       (if (< count 1)
;;           result
;;           (iter (- count 1) (cons (posn-add (car result) direction-posn) result))))
;;     (iter count (list current-posn))))

  
        


              
;; (let ([lst1 (car (read-instructions))]
;;       [lst2 (cadr (read-instructions))])
;;   (closest-intersection lst1 lst2))
