#lang racket
(require rackunit "util.rkt")


(define (get-jolts lines)
  (define sorted (sort lines <))
  (for/fold ([last 0]
             [jolts (hash 1 0 2 0 3 1)]
             #:result jolts)
            ([i (in-list sorted)])
    (let ([diff (- i last)])
      (values i (hash-update jolts diff add1)))))

(define (solve-first lines)
  (define jolts (get-jolts lines))
  (* (hash-ref jolts 1)
     (hash-ref jolts 3)))

(define (straights lines)
  (define sorted (sort lines <))
  (for/fold ([last 0]
             [subacc '()]
             [acc '()]
             #:result (if(not (empty? subacc))
                         (cons subacc acc)
                         acc))
            ([i (in-list sorted)])
    (let ([subacc-finished? (and (> (length subacc) 0)
                                   (> (- i last) 1))]
          [subacc-started? (> (length subacc) 0)]
          [1-jolt-between? (= (- i last) 1)]
          [new-values (λ (subacc acc)
                        (values i subacc acc))])
      (cond [(and (not subacc-started?)
                  1-jolt-between?) (new-values (list i last) acc)]
            [subacc-finished? (new-values '() (cons subacc acc))]
            [1-jolt-between? (new-values (cons i subacc) acc)]
            [else (new-values subacc acc)]))))

(define (solve-second lines)
  (define arrangement-count-per-places (hash 2 1
                                             3 2
                                             4 4
                                             5 7
                                             6 13))
  (define straight-lengthes (map length (straights lines)))
    (apply * (map ((curry hash-ref) arrangement-count-per-places)
                  straight-lengthes)))


(define small-example-input (list 16 10 15 5 1 11 7 19 6 12 4))

(define (binary-string->number n)
  (let loop ([n (map (compose1 string->number string)
                              (string->list n))]
             [exponent (sub1 (string-length n))])
    (if (null? n)
        0
        (+ (* (first n)(expt 2 exponent))
           (loop (rest n) (sub1 exponent))))))

(define bigger-example-input (list 28 33 18 42 31 14 46 20 48 47
                                   24 23 49 45 19 38 39 11 1 32
                                   25 35 8 17 7 9 4 2 34 10 3))

(define input (map string->number (input->lines 10)))
(module+ test
  (check-equal? (solve-first small-example-input) 35)
  (check-equal? (solve-first bigger-example-input) 220))
