#lang racket
(require rackunit "util.rkt")

(define (get-bus-ids lines)
  (filter-map (λ (x)
                (if (equal? x "x")
                    #f
                    (string->number x)))
              (string-split (second lines) ",") ))

(define (make-next-departures lines)
  (λ (timestamp)
    (define bus-ids (get-bus-ids lines))
    (define (next-departure id)
      (- id (modulo timestamp id)))
    (map next-departure bus-ids)))

(define (solve-first lines)
  (define timestamp (string->number (first lines)))
  (define bus-next-departures (map (λ (id waiting)
                                     (list id waiting))
                                   (get-bus-ids lines)
                                   ((make-next-departures lines) timestamp) ))
  (apply * (first (sort bus-next-departures (λ (n n+1)
                                              (< (second n)
                                                 (second n+1)))))))


(define (solve-second lines)
  (define next-departures (make-next-departures lines))
  (define bus-ids (get-bus-ids lines))
  (define first-bus (first bus-ids))
  (define longest-bus-loop (apply max bus-ids))
  (define constraints (for/list ([i (string-split (second lines) ",")]
                                       [c (in-naturals)]
                                       #:when (not (string=? i "x")))
                              c))
  (begin (displayln bus-ids)
         (displayln constraints)
    (for/fold ([inkrement 1])
            ([b bus-ids]
             [c constraints])
    (for/fold ([i inkrement])
                 ([_ (in-naturals)]
                  #:break (= (remainder i b) c))
         (+ i inkrement)))))
(define input (input->lines 13))

(for/fold ([inkrement 1])
            ([b '(3 5)]
             [c '(0 1)])
    (let ([new-increment (for/fold ([i inkrement])
                 ([_ (in-naturals)]
                  #:break (= (remainder i b) c))
                           (+ i inkrement))])
      (begin (displayln new-increment)
             new-increment)))

(define e.g. (list "939" "7,13,x,x,59,x,31,19"))
(module+ test
  (check-equal? (solve-first e.g.) 295)
  ;; (check-equal? (solve-second '("" "17,x,13,19")) 3417)
  ;; (check-equal? (solve-second '("" "17,x,13,19")) 3417)
  ;; (check-equal? (solve-second '("" "17,x,13,19")) 3417)
  )
