#lang racket
(require rackunit "util.rkt")


(define (make-mask str)
  (define (add-power-of-two n exponent)
    (+ n (expt 2 exponent)))
  (λ (int)
    (let-values ([(zeros ones)
                  (for/fold ([zeros 0]
                             [ones 0])
                            ([i (reverse (string->list str))]
                             [exponent (in-naturals)])
                    (match i
                      [#\X (values (add-power-of-two zeros exponent) ones)]
                      [#\0 (values zeros ones)]
                      [#\1 (values (add-power-of-two zeros exponent)
                                   (add-power-of-two ones exponent))]))])
      (bitwise-and zeros (bitwise-ior ones int)))))


(define (solve-first lines)
  (for/fold ([mask #f]
             [memory (hash)]
             #:result (for/sum ([v (in-hash-values memory)]) v))
            ([line (in-list lines)])
    (let ([pattern #px"mask = ([01X]+)|mem\\[(\\d+)\\] = (\\d+)"])
      (match (rest (regexp-match pattern line))
        [(list mask #f #f)(values (make-mask mask) memory)]
        [(list #f address value)(values mask (hash-set memory
                                                       address
                                                       (mask (string->number value))))]))))

(define (make-mem-mask str)
  "")

(define input (input->lines 14))

(module+ test
  (define test-mask (make-mask "XXXXXXXXXXXXXXXXXXXXXXXXXXXXX1XXXX0X"))
  (check-equal? (test-mask 101) 101)
  (check-equal? (test-mask 11) 73)
  (check-equal? (test-mask 0) 64))
