#lang racket
(require rackunit "util.rkt")

(define (active-cells-in-plain plain)
  (apply + (filter-map (λ (x) (if (equal? x #\#) 1 #f))
                       (string->list (apply string-append plain)))))

(define (expand-plain plain)
  (let* ([new-len (+ 2 (string-length (first plain)))]
        [inactive-line (make-string new-len #\.)])
    (list* inactive-line (append (map (λ (l) (string-append "." l "."))
                                      plain)
                                 inactive-line))))



(module+ test
  (define initial-test (list ".#." "..#" "###"))
  (check-equal? (active-cells-in-plain initial-test)5))
