#lang at-exp racket
(require rackunit "util.rkt")

(define input (input-lines 2))

(define first-check?
  (λ (min max c password)
    (let* ([count (length (filter (λ (x) (equal? c x)) (string->list password)))])
      (and (>= count min)
           (<= count max)))))


(define (second-check?  n1 n2 c password)
  (let ([pos1 (sub1 n1)]
        [pos2 (sub1 n2)])
    (xor (equal? (string-ref password pos1) c)
         (equal? (string-ref password pos2) c))))

(define (make-valid? f)
  (λ (policy+password)
    (let*-values ([(pattern) @pregexp{(\d+)-(\d+) (\w): (\w+)}]
                  [(_ n1 n2 c password)(apply values (regexp-match pattern policy+password))])
      (f (string->number n1)
         (string->number n2)
         (string-ref c 0)
         password))))

(define (solve-first lines)
  (length (filter (make-valid? first-check?) lines)))

(define (solve-second lines)
  (length (filter (make-valid? second-check?) lines)))

(module+ test
  (define input (list "1-3 a: abcde"
                      "1-3 b: cdefg"
                      "2-9 c: ccccccccc"))

  (check-equal? (solve-first input) 2)
  (check-equal? (solve-second input) 1)
  (check-equal? ((make-valid? second-check?) (first input)) #t)
  (check-equal? ((make-valid? second-check?) (third input)) #f))
