#lang racket
(require "util.rkt" rackunit)

(define (bsp-string->seat-id str)
  (define seats-per-row 8)
  (define rows 128)
  (define all-seats (build-vector (* seats-per-row rows) values))
  (define (unify-bsp-str str)
    (string-replace (string-replace str "L" "F") "R" "B"))
  (for/fold ([acc all-seats]
             #:result (vector-ref acc 0))
            ([bsp (in-list (string->list (unify-bsp-str str)))])
    (let ([p (if (equal? #\F bsp)
                 vector-take
                 vector-drop)]
          [length-half (/ (vector-length acc) 2)])
      (p acc length-half))))

(define input (input->lines 5))

(define used-seats (map bsp-string->seat-id input))

(define (solve-first)
  (apply max used-seats))

(define (solve-second)
  (define sorted-used-seats (sort used-seats <))
  (for/first ([used-seat (in-list sorted-used-seats)]
              [used-seat+1 (in-list (rest sorted-used-seats))]
              #:when (> (- used-seat+1 used-seat) 1))
    (sub1 used-seat+1)))


(module+ test
  (check-equal? (bsp-string->seat-id "FBFBBFFRLR") 357)
  (check-equal? (bsp-string->seat-id "BFFFBBFRRR") 567)
  (check-equal? (bsp-string->seat-id "FFFBBBFRRR") 119)
  (check-equal? (bsp-string->seat-id "BBFFBBFRLL") 820))
