#lang at-exp racket
(require rackunit "util.rkt")

(define (group-answers-line->yeses str)
  (define (remove-spaces str)
    (string-replace str " " ""))
  ((compose1 remove-duplicates string->list remove-spaces) str))

(define (group-answers-line->count-yeses str)
  (length (group-answers-line->yeses str)))

(define (solve-first)
(define input (input->block-lines 6))
  (apply + (map group-answers-line->count-yeses input)))

(define (group-answers-block->all-answered-yes answers)
  (define questions-answered-yes (group-answers-line->yeses (block->line answers)))
  (define (make-contains-question? question)
    (λ (answer)(string-contains? answer (string question))))
  (for/fold ([acc 0])
            ([question (in-list questions-answered-yes)])
    (let ([contains-question? (make-contains-question? question)])
      (if (andmap contains-question? answers)
          (add1 acc)
          acc))))

(define (solve-second)
(define input-blocks (input->blocks 6))
  (apply + (map group-answers-block->all-answered-yes input-blocks)))


(module+ test
  (define test-group-answer-blocks (list (list "abc")
                                         (list "a" "b" "c")
                                         (list "ab" "ac")
                                         (list "a" "a" "a" "a")
                                         (list "b")))
  (define test-group-answers (map block->line test-group-answer-blocks))

  (check-equal? (group-answers-line->count-yeses (list-ref test-group-answers 0)) 3)
  (check-equal? (group-answers-line->count-yeses (list-ref test-group-answers 1)) 3)
  (check-equal? (group-answers-line->count-yeses (list-ref test-group-answers 2)) 3)
  (check-equal? (group-answers-line->count-yeses (list-ref test-group-answers 3)) 1)
  (check-equal? (group-answers-line->count-yeses (list-ref test-group-answers 4)) 1)
  (check-equal? (group-answers-block->all-answered-yes (list-ref test-group-answer-blocks 0)) 3)
  (check-equal? (group-answers-block->all-answered-yes (list-ref test-group-answer-blocks 1)) 0)
  (check-equal? (group-answers-block->all-answered-yes (list-ref test-group-answer-blocks 2)) 1)
  (check-equal? (group-answers-block->all-answered-yes (list-ref test-group-answer-blocks 3)) 1)
  (check-equal? (group-answers-block->all-answered-yes (list-ref test-group-answer-blocks 4)) 1))
