#lang racket

(define (input->lines day)
  (file->lines (build-path ".." "input" (string-append (number->string day) ".day.txt"))))

(define (lines->blocks lines)
  (for/fold ([acc '()]
             [subacc '()]
             #:result (cons subacc acc))
            ([line (in-list (reverse lines))])
    (if (equal? line "")
        (values (cons subacc acc) '())
        (values acc (cons line subacc)))))

(define (input->blocks day)
  (define lines (input->lines day))
  (lines->blocks lines))

(define block->line
  (λ (block) (string-join block " ")))

(define (input->block-lines day)
  (define blocks (input->blocks day))
  (map block->line blocks))

(provide input->lines input->blocks input->block-lines block->line lines->blocks)
